CON
  _clkmode = 0
  _xinfreq = $4E495053 ' SPIN

OBJ
  c : "clib"

DAT
  longlist long 0
  argi long 0
  total long 0
  numfiles long 0

PUB main | argc, argv
  c.enter
  total := 0
  numfiles := 0
  argi := 1
  longlist := 0
  if argc => 2 AND byte[long[argv][1]] == "-"
    argi++
    if strcomp(long[argv][1], string("-l"))
      longlist := 1
    else
      usage
  'c.printf2(string("longlist = %d, argi = %d\n"), longlist, argi)
  if argi => argc
    listfiles(string("."))
    c.exit(@@0)
  repeat while argi < argc
    listfiles(long[argv][argi++])
  c.exit(@@0)

PUB listfiles(path) | handle, filesize, attrib, astr[2], aptr, pdirent
  handle := c.opendir(path)
  repeat while (pdirent := c.readdir(handle))
    filesize := long[pdirent][1]
    attrib := long[pdirent][0]
    total += filesize
    aptr := @astr
    c.strcpy(aptr, string("drwx"))
    repeat 4
      ifnot attrib & 8
        byte[aptr] := "-"
      aptr++
      attrib <<= 1
    if longlist
      c.printf3(STRING("%s %6d %s\n"), @astr, filesize, pdirent + 8)
    else
      c.printf1(string("%s\n"), pdirent + 8)
    numfiles++
  if longlist
    c.printf2(STRING("%6d files, %d bytes\n"), numfiles, total)
  c.closedir(handle)

PUB usage
  c.printf0(string("ls [-l] [file list]\n"))
  c.exit(@@0)
