OBJ
  rendez : "rendezvous"
  
CON
  pFileCommand = rendez#filecmd
  pFileParms   = rendez#fileparm

PRI RemoteFunctionCall(funcnum, pArgList)
  long[pFileParms] := pArgList
  long[pFileCommand] := funcnum
  repeat while long[pFileCommand]
  result := long[pFileParms]

PUB fgetc(pfileinfo)
  result := RemoteFunctionCall(1, @pfileinfo)

PUB fgets(str, num, pfileinfo)
  result := RemoteFunctionCall(2, @str)

PUB fopen(fname, mode)
  result := RemoteFunctionCall(3, @fname)

PUB fread(buffer, elem_size, num, pfileinfo)
  result := RemoteFunctionCall(4, @buffer)

PUB fwrite(buffer, elem_size, num, pfileinfo)
  result := RemoteFunctionCall(5, @buffer)

PUB fclose(pfileinfo) | file_data
  result := RemoteFunctionCall(6, @pfileinfo)

PUB remove(fname)
  result := RemoteFunctionCall(7, @fname)
    
PUB rename(fname1, fname2)
  result := RemoteFunctionCall(8, @fname1)

PUB create(fname)
  result := RemoteFunctionCall(9, @fname)

PUB getfilesize(pfileinfo)
  result := RemoteFunctionCall(10, @pfileinfo)

PUB mount(disknum, path, basepin)
  result := RemoteFunctionCall(11, @disknum)

PUB getcwd(str, num)
  result := RemoteFunctionCall(12, @str)

PUB chdir(path)
  result := RemoteFunctionCall(13, @path)

PUB format(size)
  result := RemoteFunctionCall(14, @size)

PUB opendir(path)
  result := RemoteFunctionCall(15, @path)

PUB readdir(pfileinfo)
  result := RemoteFunctionCall(16, @pfileinfo)

PUB closedir(pfileinfo)
  result := RemoteFunctionCall(17, @pfileinfo)

PUB ftell(pfileinfo)
  result := RemoteFunctionCall(18, @pfileinfo)

PUB fseek(pfileinfo, position, origin)
  result := RemoteFunctionCall(19, @pfileinfo)

PUB fflush(pfileinfo)
  result := RemoteFunctionCall(20, @pfileinfo)

PUB mkdir(fname)
  result := RemoteFunctionCall(21, @fname)

PUB chmod(fname, modebits)
  result := RemoteFunctionCall(22, @fname)

PUB getmod(fname)
  result := RemoteFunctionCall(23, @fname)

PUB run(fname, argc, argv, cognum1)
  result := RemoteFunctionCall(24, @fname)

PUB kill(cognum)
  result := RemoteFunctionCall(25, @cognum)
