CON
  _clkmode = 0
  _xinfreq = $4E495053 ' SPIN

OBJ
  c : "clib"

PUB main | argc, argv, i, infile, value ', buffer
  c.enter
{
  buffer := c.malloc(400)
  ifnot buffer
    c.printf0(string("Could not malloc buffer\n"))
}
  i := 1
  repeat
    if (argc < 2 OR c.strcmp(long[argv][i], string("-")) == 0)
      infile := c.getstdin
    else
      infile := c.fopen(long[argv][i], string("r"))
      if (infile == 0)
        c.printf1(string("Error opening %s\n"), long[argv][i])
        'c.free(buffer)
        c.exit(@@0)
      if c.getmod(long[argv][i]) & %1000 ' Check if it's a directory
        c.printf1(string("%s is a directory\n"), long[argv][i])
        'c.free(buffer)
        c.exit(@@0)
    repeat while ((value := c.fgetc(infile)) => 0)
      if (value == 0)
        c.printf0(string("\n"))
      elseif (value == 4)
        quit
      else
        c.printf1(string("%c"), value)
    if (infile <> c.getstdin)
      c.fclose(infile)
    i++
  while (i < argc)
  'c.free(buffer)
  c.exit(@@0)
