CON
  _clkmode = 0
  _xinfreq = $4E495053 ' SPIN

OBJ
  c : "clib"
  rendez : "rendezvous"

PUB main | argc, argv, buffer, infile, outfile, line, char
  c.enter

  buffer := c.malloc(100)
  ifnot buffer
    c.printf0(string("Could not malloc buffer\n"))

  if (argc < 2)
    infile := c.getstdin
  else
    infile := c.fopen(long[argv][1], string("r"))
    if (infile == 0)
      c.printf1(string("Error opening %s\n"), long[argv][1])
      c.free(buffer)
      c.exit(@@0)

  outfile := long[rendez#stdout]

  line := 0
  repeat while c.fgets(buffer, 100, infile)
    c.fputs(buffer, outfile)
    if ++line => 23
      c.printf0(string("<more>"))
      char := c.getchar
      c.printf0(string("\b\b\b\b\b\b      \b\b\b\b\b\b"))
      if char == "q" OR char == 3
        quit
      elseif char == 13
        line--
      else
        line := 0

  if (infile <> c.getstdin)
    c.fclose(infile)

  c.free(buffer)
  c.exit(@@0)
