CON
  _clkmode = 0
  _xinfreq = $4E495053 ' SPIN

OBJ
  c : "clib"
  i2c : "pasm_i2c_driver_p"
  rendez : "rendezvous"

PUB main | argc, argv, num
  c.enter
  num := i2c.Initialize(28)
  ifnot num
    c.printf0(string("Could not start I2C driver\n"))
  else
    AddToCogTable(num-1, 2, string("I2C Driver"), 0, 0)
  c.exit(@@0)

PUB AddToCogTable(cognum, type, name, startaddr, size) | entryptr
  entryptr := rendez#cogtable + (cognum * 24)
  byte[entryptr] := type
  bytemove(entryptr+1, name, 19)
  byte[entryptr+19] := 0
  word[entryptr+20] := startaddr
  word[entryptr+22] := size

